SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED
GO
-- cleanup previous removal session
IF OBJECT_ID('tempdb..#TEMP_USER_SESSION_PURGE') IS NOT NULL
	DROP TABLE #TEMP_USER_SESSION_PURGE
GO
CREATE TABLE #TEMP_USER_SESSION_PURGE (
    session_id bigINT
)
GO
CREATE INDEX IX_SID ON #TEMP_USER_SESSION_PURGE (session_id);
GO
IF OBJECT_ID('tempdb..#TEMP_USER_SESSION_PURGE_2') IS NOT NULL
	DROP TABLE #TEMP_USER_SESSION_PURGE_2
GO
CREATE TABLE #TEMP_USER_SESSION_PURGE_2 (session_id BIGINT
)
GO
DECLARE @RecordCount BIGINT
DECLARE @DeleteCount BIGINT
DECLARE @BatchCount bigINT
DECLARE @StartTime datetime
DECLARE @EndTime datetime
DECLARE @JobTimeAllowance bigint
DECLARE @transcriptDateBoundary smallint = 2
SET @JobTimeAllowance = 1
SET @StartTime = GETDATE()
SET @BatchCount = 1000
SET @DeleteCount  = 5000
SET @RecordCount = 500000
SET @EndTime = DATEADD(HOUR, @JobTimeAllowance, @StartTime)


WHILE ( ( @DeleteCount > @BatchCount ) AND ( @ENDTIME > GETDATE() ) )
    BEGIN
        INSERT INTO #TEMP_USER_SESSION_PURGE
        SELECT TOP (@RecordCount) session_id
        FROM PPS_USER_SESSIONS us WITH(NOLOCK)
        WHERE 
			NOT EXISTS(SELECT SESSION_ID FROM PPS_TRANSCRIPTS t WITH(NOLOCK) WHERE us.SESSION_ID = t.SESSION_ID AND (t.status <> 'N' OR t.date_created > GETUTCDATE() - @transcriptDateBoundary))
			AND NOT EXISTS(SELECT SESSION_ID FROM PPS_TRAINING_LICENSE_ACTIVITY tla WITH(NOLOCK) WHERE us.SESSION_ID = tla.SESSION_ID)
			AND NOT EXISTS(SELECT SESSION_ID FROM PPS_CLOUD_STOR_REQUEST csr WITH(NOLOCK) WHERE us.SESSION_ID = csr.SESSION_ID)
			AND DATE_CREATED < GETUTCDATE()-.5;
        SET @DeleteCount = (SELECT COUNT(*) FROM #TEMP_USER_SESSION_PURGE);
        WHILE ((select COUNT(*) from #TEMP_USER_SESSION_PURGE) > 0 AND @ENDTIME > GETDATE())
            BEGIN
                INSERT INTO #TEMP_USER_SESSION_PURGE_2
                SELECT TOP (@BatchCount) session_id
                FROM #TEMP_USER_SESSION_PURGE
					 
					 DELETE FROM PPS_USER_SESSION_DESKTOP_CLIENTS
							WHERE SESSION_ID IN (SELECT SESSION_ID FROM #TEMP_USER_SESSION_PURGE_2 WITH(NOLOCK));
					 DELETE FROM PPS_USER_SESSION_MOBILE_CLIENTS
							WHERE SESSION_ID IN (SELECT SESSION_ID FROM #TEMP_USER_SESSION_PURGE_2 WITH(NOLOCK));
					 DELETE FROM PPS_TRANSCRIPTS
							WHERE SESSION_ID IN (SELECT SESSION_ID FROM #TEMP_USER_SESSION_PURGE_2 WITH(NOLOCK))
								AND STATUS = 'N' AND date_created < GETUTCDATE() - @transcriptDateBoundary

					DELETE FROM PPS_USER_SESSIONS
						WHERE SESSION_ID IN (SELECT SESSION_ID FROM #TEMP_USER_SESSION_PURGE_2 WITH(NOLOCK));
       
                DELETE FROM #TEMP_USER_SESSION_PURGE
						WHERE SESSION_ID IN (SELECT SESSION_ID FROM #TEMP_USER_SESSION_PURGE_2 NOLOCK);
       
                TRUNCATE TABLE #TEMP_USER_SESSION_PURGE_2;
       
                WAITFOR DELAY '00:00:01';
            END
        TRUNCATE TABLE #TEMP_USER_SESSION_PURGE;
    END
GO
IF OBJECT_ID('tempdb..#TEMP_USER_SESSION_PURGE') IS NOT NULL
	DROP TABLE #TEMP_USER_SESSION_PURGE
GO
IF OBJECT_ID('tempdb..#TEMP_USER_SESSION_PURGE_2') IS NOT NULL
	DROP TABLE #TEMP_USER_SESSION_PURGE_2
GO
UPDATE STATISTICS PPS_USER_SESSIONS;
GO
